/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Model;

import java.util.*;
import java.io.*;

/**
 *
 * @author moacir
 */
public class BookShelf {

    // nome do arquivo BookShelf$StatusBook.class
    private class StatusBook {
        public Book book;
        public boolean active;
        public StatusBook(Book b, boolean a) {
            book = b;
            active = a;
        }
    }

    private ArrayList<StatusBook> list;

    public BookShelf () {
        list = new ArrayList<StatusBook>();
    }

    public void insertBook(String title, String author, int year ) {
        Book b1 = new Book(title,author,year);
        // supondo que todo livro inserido tem status = true
        StatusBook sb1 = new StatusBook(b1, true);
        list.add(sb1);
    }

    public void insertBook(String title, String author, int year, boolean status ) {
        Book b1 = new Book(title,author,year);
        // supondo que todo livro inserido tem status = true
        StatusBook sb1 = new StatusBook(b1, status);
        list.add(sb1);
    }

    public void insertBook(Book b1) {
        // supondo que todo livro inserido tem status = true
        StatusBook sb1 = new StatusBook(b1, true);
        list.add(sb1);
    }

    public int numberOfBooks() {
        return list.size();
    }

    public void removeBook(int removecode) {
        Iterator<StatusBook> it = list.iterator();

        while (it.hasNext()) {
            // acesso o iterador de um objeto StatusBook e retorno
            // a referencia do atributo 'book'
            Book b1 = (Book)it.next().book;
            if (b1.getCode() == removecode)
                it.remove();
        }
    }

    public void removeBook(Book removebook) {
        Iterator<StatusBook> it = list.iterator();

        while (it.hasNext()) {
            Book b1 = (Book)it.next().book;
            if (b1.equals(removebook))
                it.remove();
        }
    }

    public Iterator<Book> getListofBooks() {
        // cria um arraylist de Book do tamanho de 'list'
        ArrayList<Book> booklist = new ArrayList<Book>(list.size());
        Iterator<StatusBook> it = list.iterator();
        // copia dos objetos 
        while (it.hasNext()) {
            booklist.add((Book)it.next().book);
        }
        return booklist.iterator();
    }

    public boolean getStatus(int code) {
        Iterator<StatusBook> it = list.iterator();
        // copia dos objetos
        while (it.hasNext()) {
            StatusBook sb1 = it.next();
            if (sb1.book.getCode() == code) {
                return sb1.active;
            }
        }
        return false;
    }

    public void changeStatus(int code) {
        Iterator<StatusBook> it = list.iterator();
        // copia dos objetos
        while (it.hasNext()) {
            StatusBook sb1 = it.next();
            if (sb1.book.getCode() == code) {
                sb1.active = !sb1.active;
            }
        }
    }

    public void setCover(int code, String cover) {
        Iterator<StatusBook> it = list.iterator();
        // copia dos objetos
        while (it.hasNext()) {
            StatusBook sb1 = it.next();
            if (sb1.book.getCode() == code) {
                sb1.book.setCover(cover);
            }
        }
    }

    public String getCover(int code) {
        Iterator<StatusBook> it = list.iterator();
        // copia dos objetos
        while (it.hasNext()) {
            StatusBook sb1 = it.next();
            if (sb1.book.getCode() == code) {
                return sb1.book.getCover();
            }
        }
        return "";
    }

    public int loadFromFile() {

      int regcount = 0;
      boolean repeat = false;

      do {
            repeat = false;
            
            File file = new File("/home/moacir/NetBeansProjects/BookList/Livros.txt");
            //Cria um FileReader para obter dados a partir de 'file'
            FileReader reader;
            //Cria um BufferReader para obter os seus dados a partir de um Reader
            BufferedReader br;

            try {
                reader = new FileReader(file);
                br = new BufferedReader(reader);

                while (br.ready()) {
                    String title_read;
                    String author_read;
                    int year_read;
                    String cover_read;

                    // cada livro e representado por 4 linhas no arquivo
                    title_read = br.readLine();
                    author_read = br.readLine();
                    year_read = (int)Integer.parseInt(br.readLine());
                    cover_read = br.readLine();

                    Book book_read = new Book(title_read,author_read,year_read,cover_read);
                    insertBook(book_read);
                    regcount++;
                }
            }
            catch (FileNotFoundException ex) {
                Object[] options = {"Tentar novamente", "Sair"};
                int n = javax.swing.JOptionPane.showOptionDialog(null, "Arquivo nao encontrado",
                    "Erro", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE,
                    null, options, options[1]);
                System.out.println("retorno: "+n);
                if (n == 1) {
                    ex.printStackTrace();
                    System.exit(1);
                } else {
                    repeat = true;
                }
            }
            catch (IOException ex) {
                ex.printStackTrace();
            }
      } while (repeat);

      return regcount;
    }

   public void fileWrite() {

        File file = new File("/home/moacir/NetBeansProjects/BookList/Livros.txt");
        //Cria um FileReader para obter dados a partir de 'file'
        FileWriter writer = null;
        //Cria um BufferReader para obter os seus dados a partir de um Reader
        BufferedWriter bw = null;

        try {
            writer = new FileWriter(file);
            //Cria um objeto File e abre "src\\arquivos\\Dados.txt"
            bw = new BufferedWriter(writer);

            Iterator<StatusBook> it = list.iterator();
            while (it.hasNext()) {
                Book bookwrite = it.next().book;
                bw.write(bookwrite.getTitle());
                bw.newLine();
                bw.write(bookwrite.getAuthor());
                bw.newLine();
                bw.write((String)""+bookwrite.getYear());
                bw.newLine();
                if ((bookwrite.getCover() == null) || (bookwrite.getCover().length() < 5)) {
                    bw.write(".");
                } else {
                    bw.write(bookwrite.getCover());
                }
                bw.newLine();
                //Lê os dados do arquivo txt
                System.out.println("Book written: " + bookwrite.getDescription());
            }
        }
        catch(FileNotFoundException ex) {
             System.err.println("FileNotFoundException: " + ex.getMessage());
             //throw new SampleException(e);
        }
        catch(IOException ex) {
            ex.printStackTrace();
        }
        finally {
            //Close the BufferedWriter
            try {
                if (bw != null) {
                    bw.flush();
                    bw.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }


}
